
#ifdef __cplusplus
extern "C" {
#endif

enum {
	SXSIMEDIA_DATA = 0x10,
	SXSIMEDIA_AUDIO = 0x20
};

#ifdef SUPPORT_KAI_IMAGES

// WinDDK̍\̖̂OƔ̂ TRACK -> TRACKTYPE ɕύX np21w ver0.86 rev33
#define	TRACKTYPE_DATA	0x14
#define	TRACKTYPE_AUDIO	0x10

typedef struct {
	UINT8	adr_ctl;		//	Adr/Ctl
							//		ISO:0x14
							//		CUE:MODE1=0x14AMODE2=0x14AAUDIO=0x10
							//		CCD:
							//		CDM:
							//		MDS:MDS_TrackBlock.adr_ctl
	UINT8	point;			//	Track Number
							//		ISO:1
							//		CUE:TRACK ??=??
							//		CCD:
							//		CDM:
							//		MDS:MDS_TrackBlock.point
	UINT32	pos;			//	gbÑC[Wt@Cł̊JnZN^ʒu
							//		ISO:0
							//		CUE:INDEX 1
							//		CCD:
							//		CDM:
							//		MDS:((MDS_TrackBlock.min * 60) + MDS_TrackBlock.sec) * 75 + MDS_TrackBlock.frame
//	--------
	UINT32	pos0;			//	CUEV[g"INDEX 00"Ŏw肳ꂽPREGAP̃C[Wł̊JnZN^ʒu
							//		ISO:0
							//		CUE:INDEX 0
							//		CCD:
							//		CDM:
							//		MDS:0
	UINT32	str_sec;		//	gbÑC[Wt@Cł̊JnZN^ʒu
							//		ISO:
							//		CUE:
							//		CCD:
							//		CDM:
							//		MDS:
	UINT32	end_sec;		//	gbÑC[Wt@Cł̏IZN^ʒu
							//		ISO:
							//		CUE:
							//		CCD:
							//		CDM:
							//		MDS:
	UINT32	sectors;		//	gbÑC[Wt@Cł̃ZN^
							//		ISO:
							//		CUE:
							//		CCD:
							//		CDM:
							//		MDS:
//	--------
	UINT16	sector_size;	//	gbÑZN^TCY
							//		ISO:2048 or 2352 or 2448(t@CTCYė]̏oȂl)
							//		CUE:MODE1/????=????AMODE2/????=????AAUDIO=2352
							//		CCD:2352(ŒŐH)
							//		CDM:2352(ŒŐH)
							//		MDS:MDS_TrackBlock.sector_size
							//		NRG:NRG_DAO_Block.sector_size

	//	CD̊eZN^Jnʒu
	//	C[Wt@CPREGAP̈ɂČq̃C[Wt@C̊eZN^Jnʒu
	//	@ꂽlɂȂ邱Ƃ
	UINT32	pregap_sector;	//	gbNPREGAPJnZN^ʒu
							//	PREGAPꍇPREGAP̎̂ꍇ
							//	@gbNstart_sectorƓl
							//		ISO:0
							//		CUE:
							//		CCD:
							//		CDM:
							//		MDS:start_sector - pregap_sectors
	UINT32	start_sector;	//	gbN̊JnZN^ʒu
							//		ISO:0
							//		CUE:
							//		CCD:
							//		CDM:
							//		MDS:MDS_TrackBlock.start_sector(gGfBA)
	UINT32	end_sector;		//	gbN̏IZN^ʒu
							//		ISO:track_sectors - 1
							//		CUE:
							//		CCD:
							//		CDM:
							//		MDS:start_sector + track_sectors - 1

	//	C[Wt@C̊eZN^Jnʒu
	UINT32	img_pregap_sec;	//	gbNPREGAPJnZN^ʒu
							//	PREGAPꍇPREGAP̎̂ꍇ
							//	@gbNstart_sectorƓl
							//		ISO:0
							//		CUE:
							//		CCD:
							//		CDM:
							//		MDS:
	UINT32	img_start_sec;	//	gbN̊JnZN^ʒu
							//		ISO:0
							//		CUE:
							//		CCD:
							//		CDM:
							//		MDS:
	UINT32	img_end_sec;	//	gbN̏IZN^ʒu
							//		ISO:track_sectors - 1
							//		CUE:
							//		CCD:
							//		CDM:
							//		MDS:

	//	eZN^JnʒũC[Wt@Cłoffset
	UINT64	pregap_offset;	//	C[Wt@C̃gbNPREGAPoffset
							//	ʏ͑OgbNend_offsetƓl
							//	PREGAPꍇPREGAP̎̂ꍇ
							//	@start_offsetƓl
							//		ISO:0
							//		CUE:
							//		CCD:
							//		CDM:
							//		MDS:start_offset
	UINT64	start_offset;	//	C[Wt@C̃gbNJnʒuoffset
							//	PREGAPꍇPREGAP̎̂ꍇ
							//	@OgbNend_offsetƓl
							//		ISO:0
							//		CUE:
							//		CCD:
							//		CDM:
							//		MDS:MDS_TrackBlock.start_offset(gGfBA)
	UINT64	end_offset;		//	C[Wt@C̃gbNIʒuoffset
							//		ISO:track_sectors * sector_size
							//		CUE:
							//		CCD:
							//		CDM:
							//		MDS:start_offset + (track_sectors * sector_size)

	UINT32	pregap_sectors;	//	gbNPREGAP̃ZN^
							//		ISO:0
							//		CUE:PREGAP
							//		CCD:
							//		CDM:
							//		MDS:MDS_TrackExtraBlock.pregap(gGfBA)
	UINT32	track_sectors;	//	gbÑZN^
							//		ISO:t@CTCY / sector_size
							//		CUE:
							//		CCD:
							//		CDM:
							//		MDS:MDS_TrackExtraBlock.length(gGfBA)
//	--------
} _CDTRK, *CDTRK;

#else
typedef struct {
	UINT8	type;
	UINT8	track;
	FILEPOS	pos;
} _CDTRK, *CDTRK;

#endif

BRESULT sxsicd_open(SXSIDEV sxsi, const OEMCHAR *fname);

CDTRK sxsicd_gettrk(SXSIDEV sxsi, UINT *tracks);
BRESULT sxsicd_readraw(SXSIDEV sxsi, FILEPOS pos, void *buf);

#ifdef __cplusplus
}
#endif

