// ---------------------------------------------------------------------------
//	PSG-like sound generator
//	Copyright (C) cisc 1997, 1999.
// ---------------------------------------------------------------------------
//	$Id: psg.h,v 1.8 2003/04/22 13:12:53 cisc Exp $

#ifndef PSG_H
#define PSG_H

#include "fmgen_types.h"

#define PSG_SAMPLETYPE		int32		// int32 or int16

// ---------------------------------------------------------------------------
//	class PSG
//	PSG ɗǂ𐶐鉹jbg
//	
//	interface:
//	bool SetClock(uint clock, uint rate)
//		D̃NXgpOɂȂ炸ĂłƁD
//		PSG ̃NbN PCM [gݒ肷
//
//		clock:	PSG ̓NbN
//		rate:	 PCM ̃[g
//		retval	ɐ true
//
//	void Mix(Sample* dest, int nsamples)
//		PCM  nsamples C dest Ŏn܂zɉ(Z)
//		܂ŉZȂ̂ŁCŏɔz[NAKv
//	
//	void Reset()
//		Zbg
//
//	void SetReg(uint reg, uint8 data)
//		WX^ reg  data 
//	
//	uint GetReg(uint reg)
//		WX^ reg ̓eǂݏo
//	
//	void SetVolume(int db)
//		ẻʂ𒲐߂
//		Pʂ͖ 1/2 dB
//
struct PSGData {
	uint8 reg[16];
	uint olevel[3];
	uint32 scount[3];
	uint32 speriod[3];
	uint32 ecount;
	uint32 eperiod;
	uint32 ncount;
	uint32 nperiod;
	uint32 tperiodbase;
	uint32 eperiodbase;
	uint32 nperiodbase;
	int volume;
	int mask;
};

class PSG
{
public:
	typedef PSG_SAMPLETYPE Sample;
	
	enum
	{
		noisetablesize = 1 << 11,	// gpʂ炵Ȃ猸炵
		toneshift = 24,
		envshift = 22,
		noiseshift = 14,
		oversampling = 2,		//  葬xDȂ猸炷Ƃ
	};

public:
	PSG();
	~PSG();

	void Mix(Sample* dest, int nsamples);
	void SetClock(int clock, int rate);
	
	void SetVolume(int vol);
	void SetChannelMask(int c);
	
	void Reset();
	void SetReg(uint regnum, uint8 data);
	uint GetReg(uint regnum) { return reg[regnum & 0x0f]; }

	void DataSave(struct PSGData* data);
	void DataLoad(struct PSGData* data);
	
protected:
	void MakeNoiseTable();
	void MakeEnvelopTable();
	static void StoreSample(Sample& dest, int32 data);
	
	uint8 reg[16];

	const uint* envelop;
	uint olevel[3];
	uint32 scount[3], speriod[3];
	uint32 ecount, eperiod;
	uint32 ncount, nperiod;
	uint32 tperiodbase;
	uint32 eperiodbase;
	uint32 nperiodbase;
	int volume;
	int mask;

	static uint enveloptable[16][64];
	static uint noisetable[noisetablesize];
	static int EmitTable[32];
};

#endif // PSG_H
